/*
 * RCS info: $Source: $
 *           $Revision: $
 *           $Date: $
 *           $Author:$
 *           $Log:  $
 *
 * Copyright (c) 2012 ISHIZUE Design Automation Corp.
 */

/*============================================================================
 * 쐬F
 * 쐬ҁF
 * t@CFdsp_div.h
 * Tv  FŒ菬_^̊Z֐i@j
 *       F 2012/12 jA
 *==========================================================================*/

#ifndef _FPF_DIVFUNC
#define _FPF_DIVFUNC

/************************************************************************
  Œ菬_^̊Z֐i@j
  @\
@    q = a/b;
  @  폜Fa
@@@  Fb
@@@@  Fq
  ֐F
      unsigned long long _FPFSIM_divCom64(
            unsigned long long a_val, int a_iw, int a_fw,
            unsigned long long b_val, int b_iw, int b_fw,
            int qfw,
            unsigned long long *qr_val, int *qr_iw, int *qr_fw )

      unsigned long long _FPFSIM_divCom32(
            unsigned long long a_val, int a_iw, int a_fw,
            unsigned long long b_val, int b_iw, int b_fw,
            int qw,
            unsigned long long *qr_val, int *qr_iw, int *qr_fw )

  
     a_i a_f a_val   F폜̐x
     b_i b_f b_val   F̐x
     qfw @    @@@FKvȏ̏rbg

   qr_i qr_f qr_valFZʂ̏̐xƒl

  
     0 : I
     1 : 32rbgI[o[

*************************************************************************/

#ifdef __FPF_MAX_16BIT

#define _FPFDIV_WORD_SIZE           16
#define _FPFDIV_HIBIT               (0x80000000UL)
#define _FPFSIM_llisize             32
typedef signed long     _FPFDIV_LNG_SDWORD;     // gint64
typedef unsigned long   _FPFDIV_LNGUDWORD;      // guint64

#else

#define _FPFDIV_WORD_SIZE           32
#define _FPFDIV_HIBIT               (0x8000000000000000ULL)
#define _FPFSIM_llisize             64
typedef signed long long    _FPFDIV_LNG_SDWORD;     // gint64
typedef unsigned long long  _FPFDIV_LNG_UDWORD;     // guint64

#endif

/* ==========================
    sizeof(int)*2rbg
 ============================ */

typedef struct
{
    _FPFDIV_LNG_UDWORD hi;
    _FPFDIV_LNG_UDWORD lo;
    short isneg;    /**< sign-bit -- T if number is negative */
    short isbig;    /**< sizeflag -- T if number won't fit in signed 64-bit */
} _FPFDIV_QWORD;

/** Shift leftt by one bit (i.e. multiply by two) */
static _FPFDIV_QWORD _FPFDIV_shiftleft128 (_FPFDIV_QWORD x)
{
    _FPFDIV_LNG_UDWORD sbit;
    sbit = x.lo & _FPFDIV_HIBIT;
    x.hi <<= 1;
    x.lo <<= 1;
    x.isbig = 0;
    if (sbit){
        x.hi |= 1;
        x.isbig = 1;
        return x;
    }

    if (x.hi){
        x.isbig = 1;
    }
    return x;
}

/** Divide a signed 128-bit number by a signed 64-bit,
 *  returning a signed 128-bit number.
 */
static _FPFDIV_QWORD _FPFDIV_div128 (
    _FPFDIV_QWORD n,
    _FPFDIV_LNG_SDWORD d
)
{
    _FPFDIV_QWORD quotient;
    int i;
    _FPFDIV_LNG_UDWORD remainder = 0;

    quotient = n;
    if(0 > d){
        d = -d;
        quotient.isneg = !quotient.isneg;
    }

    /* Use grade-school long division algorithm */
    for (i = 0; i < 128; i++){
        _FPFDIV_LNG_UDWORD sbit = _FPFDIV_HIBIT & quotient.hi;
        remainder <<= 1;
        if (sbit) remainder |= 1;
        quotient = _FPFDIV_shiftleft128 (quotient);
        if (remainder >= d){
            remainder -= d;
            quotient.lo |= 1;
        }
    }

    /* compute the carry situation */
    quotient.isbig = (quotient.hi || (quotient.lo >> 63));

    return quotient;
}

// Z֐{
// 
static _FPFDIV_LNG_UDWORD _FPFSIM_ldiv(
    _FPFDIV_LNG_UDWORD av,
    _FPFDIV_LNG_UDWORD bv)
{
    _FPFDIV_QWORD t_av, qv;
    _FPFDIV_LNG_SDWORD t_bv;

    t_av.hi=0; t_av.lo=av;
    t_bv = bv;

    qv = _FPFDIV_div128 (t_av, t_bv);
    return qv.lo;
}


static _FPFDIV_LNG_UDWORD _FPFSIM_divCom64(
    _FPFDIV_LNG_UDWORD a_val, int a_iw, int a_fw,
    _FPFDIV_LNG_UDWORD b_val, int b_iw, int b_fw,
    int dw, int qfw,
    _FPFDIV_LNG_UDWORD *qr_val, int *qr_iw, int *qr_fw )
{
    int alpha=qfw-(a_fw-b_fw);

    if(alpha<0) b_val=b_val<<(-alpha);
    if(alpha>0) a_val=a_val<<(alpha);

    *qr_val=_FPFSIM_ldiv(a_val, b_val);

    *qr_fw=qfw;
    *qr_iw=dw-qfw-1;

    return 0;
}

// div unsigned * unsigned
static _FPFDIV_LNG_UDWORD _FPFSIM_divUU64(
    _FPFDIV_LNG_UDWORD a_val, int a_iw, int a_fw,
    _FPFDIV_LNG_UDWORD b_val, int b_iw, int b_fw,
    int qw, int y_fw )
{
    _FPFDIV_LNG_UDWORD qr_val;
    int qr_iw, qr_fw;

    _FPFSIM_divCom64(
            a_val, a_iw, a_fw,
            b_val, b_iw, b_fw,
            qw, y_fw, &qr_val, &qr_iw, &qr_fw );

    if( y_fw > qr_fw ){
        qr_val = qr_val << (y_fw - qr_fw);
    } else {
        qr_val = qr_val >> (qr_fw - y_fw);
    }
    return qr_val;
}

// div unsigned * signed
static _FPFDIV_LNG_SDWORD _FPFSIM_divUS64(
    _FPFDIV_LNG_UDWORD a_val, int a_iw, int a_fw,
    _FPFDIV_LNG_SDWORD b_val, int b_iw, int b_fw,
    int qw, int y_fw )
{
    _FPFDIV_LNG_SDWORD qr_val;
    int qr_iw, qr_fw;
    int b_sgnd = 0;

    if( b_val < 0 ){
        b_val = -b_val;
        b_sgnd = 1;
    }

    _FPFSIM_divCom64(
            a_val, a_iw, a_fw,
            (_FPFDIV_LNG_UDWORD)b_val, b_iw, b_fw,
            qw, y_fw, (_FPFDIV_LNG_UDWORD*)&qr_val, &qr_iw, &qr_fw );

    if( y_fw > qr_fw ){
        qr_val = qr_val << (y_fw - qr_fw);
    } else {
        qr_val = qr_val >> (qr_fw - y_fw);
    }

    if( b_sgnd == 1 ){
        qr_val = -(qr_val);
    }
    return qr_val;
}

// div signed * unsigned
static _FPFDIV_LNG_SDWORD _FPFSIM_divSU64(
    _FPFDIV_LNG_SDWORD a_val, int a_iw, int a_fw,
    _FPFDIV_LNG_UDWORD b_val, int b_iw, int b_fw,
    int qw, int y_fw )
{
    _FPFDIV_LNG_SDWORD qr_val;
    int qr_iw, qr_fw;
    int a_sgnd = 0;

    if( a_val < 0 ){
        a_val = -a_val;
        a_sgnd = 1;
    }

    _FPFSIM_divCom64(
            (_FPFDIV_LNG_UDWORD)a_val, a_iw, a_fw,
            b_val, b_iw, b_fw, qw, y_fw,
            (_FPFDIV_LNG_UDWORD *)&qr_val, &qr_iw, &qr_fw );

    if( y_fw > qr_fw ){
        qr_val = qr_val << (y_fw - qr_fw);
    } else {
        qr_val = qr_val >> (qr_fw - y_fw);
    }

    if( a_sgnd == 1 ){
        qr_val = -(qr_val);
    }
    return qr_val;
}

// div signed * signed
static _FPFDIV_LNG_SDWORD _FPFSIM_divSS64(
    _FPFDIV_LNG_SDWORD a_val, int a_iw, int a_fw,
    _FPFDIV_LNG_SDWORD b_val, int b_iw, int b_fw,
    int qw, int y_fw )
{
    _FPFDIV_LNG_SDWORD qr_val;
    int qr_iw, qr_fw;
    int a_sgnd = 0;
    int b_sgnd = 0;

    if( a_val < 0 ){
        a_val = -a_val;
        a_sgnd = 1;
    }
    if( b_val < 0 ){
        b_val = -b_val;
        b_sgnd = 1;
    }

    _FPFSIM_divCom64(
            (_FPFDIV_LNG_UDWORD)a_val, a_iw, a_fw,
            (_FPFDIV_LNG_UDWORD)b_val, b_iw, b_fw,
            qw, y_fw, (_FPFDIV_LNG_UDWORD *)&qr_val, &qr_iw, &qr_fw );

    if( y_fw > qr_fw ){
        qr_val = qr_val << (y_fw - qr_fw);
    } else {
        qr_val = qr_val >> (qr_fw - y_fw);
    }

    if( (a_sgnd == 1 && b_sgnd == 0) || (a_sgnd == 0 && b_sgnd == 1) ){
        qr_val = -(qr_val);
    }
    return qr_val;
}

/* ======================
    int(32) rbg
 ======================== */

//in rbg
typedef unsigned int _FPFDIV_WORD;

//int*2 rbg
typedef struct {
    _FPFDIV_WORD dwHigh; //32rbg
    _FPFDIV_WORD dwLow;  //32rbg
} _FPFDIV_DWORD;

// 32x264rbgVtg
static _FPFDIV_DWORD _FPFDIV_lshift64(_FPFDIV_DWORD dw, int sfnum)
{
    _FPFDIV_WORD tmp;

    if (sfnum>_FPFDIV_WORD_SIZE) {
        tmp = dw.dwLow<<(sfnum-_FPFDIV_WORD_SIZE);
        dw.dwLow  = 0;
        dw.dwHigh = tmp;
    } else {
        tmp = dw.dwLow>>(_FPFDIV_WORD_SIZE-sfnum);
        if( sfnum == _FPFDIV_WORD_SIZE ){
            dw.dwLow = 0;
        } else {
            dw.dwLow = dw.dwLow<<(sfnum);
        }
        dw.dwHigh = dw.dwHigh<<(sfnum);
        dw.dwHigh = dw.dwHigh|tmp;
    }
    return dw;
}

// 32x264rbgEVtg
static _FPFDIV_DWORD _FPFDIV_rshift64(_FPFDIV_DWORD dw, int sfnum)
{
    _FPFDIV_WORD tmp;

    /* Shifting */
    if (sfnum>_FPFDIV_WORD_SIZE) {
        tmp = dw.dwHigh>>(sfnum-_FPFDIV_WORD_SIZE);
        dw.dwHigh  = 0;
        dw.dwLow = tmp;
    } else {
        tmp = dw.dwHigh<<(_FPFDIV_WORD_SIZE-sfnum);
        dw.dwLow  = dw.dwLow>>sfnum;
        dw.dwHigh = dw.dwHigh>>sfnum;
        dw.dwLow  = dw.dwLow|tmp;
    }
    return dw;
}

// r >=
static int _FPFDIV_comp64_ge(_FPFDIV_DWORD dw1, _FPFDIV_DWORD dw2)
{
    if(dw1.dwHigh>dw2.dwHigh) return 1;
    if(dw1.dwHigh<dw2.dwHigh) return 0;

    if(dw1.dwLow>dw2.dwLow) return 1;
    if(dw1.dwLow<dw2.dwLow) return 0;

    return 1; // equal
}

// Z֐{

static unsigned int _FPFSIM_i_init(
        _FPFDIV_DWORD a, _FPFDIV_DWORD b, unsigned int* pos)
{
    int i;
    _FPFDIV_DWORD ax;
    unsigned char ca;
    _FPFDIV_DWORD tmp;

    ax.dwHigh=0;
    ax.dwLow=0;
    ca=0;
    for (i=_FPFSIM_llisize-1; i>=0; i--) {
        ca = (_FPFDIV_rshift64(a,i)).dwLow&0x01;
        ax.dwLow = (_FPFDIV_lshift64(ax,1)).dwLow|(ca);
        tmp=_FPFDIV_lshift64(b,1);
        if ((_FPFDIV_comp64_ge(tmp,ax)) && (_FPFDIV_comp64_ge(ax,b))) break;
    }
    *pos=i;

    return ax.dwLow;
}

static unsigned int _FPFSIM_idiv(_FPFDIV_DWORD av, _FPFDIV_DWORD bv)
{
    unsigned char ca;
    int ax=0, q=0;
    int i=0, pos=0;
    unsigned int nn=0, nnp=0;
    _FPFDIV_DWORD a, b;

    a=av; b=bv;
    ax=0; ca = 0; 

    ax=_FPFSIM_i_init(a, b, (unsigned int*)&pos);

    if(pos>_FPFDIV_WORD_SIZE) {
//      __fpfsim_divfunc_overflowFlg = 1;
//      printf("********  idiv :: overflow 32bits\n");
        return 0;
    }
    ax=ax-b.dwLow;                         // ax = ax - b;  ???
    for (i=pos-1; i>=0; i--) {
        ca = (_FPFDIV_rshift64(a,i)).dwLow&0x01;     //   (a>>i)&0x01;
        ax = (ax<<1)|(ca);
        if(ax<0) {
            q = (q<<1)|0x00;
            ax = ax + b.dwLow;
        } else {
            q = (q<<1)|0x01;
            ax = ax - b.dwLow;
        }
    }

    if(ax<0){
       q = (q<<1)|0x00;
    } else {
       q = (q<<1)|0x01;
    }

    // *r=ax;   ]
    return q;
}

static unsigned int _FPFSIM_divCom32(
    unsigned int a_val, int a_iw, int a_fw,
    unsigned int b_val, int b_iw, int b_fw,
    int dw, int qfw,
    unsigned int *qr_val, int *qr_iw, int *qr_fw )
{
    int alpha=qfw-(a_fw-b_fw);

    _FPFDIV_DWORD ad_val;
    _FPFDIV_DWORD bd_val;

    ad_val.dwHigh=0;
    ad_val.dwLow=a_val;
    bd_val.dwHigh=0;
    bd_val.dwLow=b_val;

    if(alpha<0) bd_val=_FPFDIV_lshift64(bd_val, (-alpha));
    if(alpha>0) ad_val=_FPFDIV_lshift64(ad_val, alpha);

    *qr_val=_FPFSIM_idiv(ad_val, bd_val);

    *qr_fw=qfw;
    *qr_iw=dw-qfw-1;

   return 0;
}

// div unsigned * unsigned
static unsigned int _FPFSIM_divUU32(
    unsigned int a_val, int a_iw, int a_fw,
    unsigned int b_val, int b_iw, int b_fw,
    int qw, int y_fw )
{
    unsigned int qr_val;
    int qr_iw, qr_fw;

    _FPFSIM_divCom32(
            a_val, a_iw, a_fw, b_val,
            b_iw, b_fw, qw, y_fw, &qr_val, &qr_iw, &qr_fw );

    if( y_fw > qr_fw ){
        qr_val = qr_val << (y_fw - qr_fw);
    } else {
        qr_val = qr_val >> (qr_fw - y_fw);
    }
    return qr_val;
}

// div unsigned * signed
static int _FPFSIM_divUS32(
    unsigned int a_val, int a_iw, int a_fw,
    int b_val, int b_iw, int b_fw,
    int qw, int y_fw )
{
    int qr_val;
    int qr_iw, qr_fw;
    int b_sgnd = 0;

    if( b_val < 0 ){
        b_val = -b_val;
        b_sgnd = 1;
    }

    _FPFSIM_divCom32(
            a_val, a_iw, a_fw,
            (unsigned int)b_val, b_iw, b_fw,
            qw, y_fw, (unsigned int*)&qr_val, &qr_iw, &qr_fw );

    if( y_fw > qr_fw ){
        qr_val = qr_val << (y_fw - qr_fw);
    } else {
        qr_val = qr_val >> (qr_fw - y_fw);
    }

    if( b_sgnd == 1 ){
        qr_val = -(qr_val);
    }
    return qr_val;
}

// div signed * unsigned
static int _FPFSIM_divSU32(
    int a_val, int a_iw, int a_fw,
    unsigned int b_val, int b_iw, int b_fw,
    int qw, int y_fw )
{
    int qr_val;
    int qr_iw, qr_fw;
    int a_sgnd = 0;

    if( a_val < 0 ){
        a_val = -a_val;
        a_sgnd = 1;
    }

    _FPFSIM_divCom32(
            (unsigned int)a_val, a_iw, a_fw,
            b_val, b_iw, b_fw,
            qw, y_fw, (unsigned int*)&qr_val, &qr_iw, &qr_fw );

    if( y_fw > qr_fw ){
        qr_val = qr_val << (y_fw - qr_fw);
    } else {
        qr_val = qr_val >> (qr_fw - y_fw);
    }

    if( a_sgnd == 1 ){
        qr_val = -(qr_val);
    }
    return qr_val;
}

// div signed * signed
static int _FPFSIM_divSS32(
    int a_val, int a_iw, int a_fw,
    int b_val, int b_iw, int b_fw,
    int qw, int y_fw )
{
    int qr_val;
    int qr_iw, qr_fw;
    int a_sgnd = 0;
    int b_sgnd = 0;

    if( a_val < 0 ){
        a_val = -a_val;
        a_sgnd = 1;
    }
    if( b_val < 0 ){
        b_val = -b_val;
        b_sgnd = 1;
    }

    _FPFSIM_divCom32(
            (unsigned int)a_val, a_iw, a_fw,
            (unsigned int)b_val, b_iw, b_fw,
            qw, y_fw, (unsigned int*)&qr_val, &qr_iw, &qr_fw );

    if( y_fw > qr_fw ){
        qr_val = qr_val << (y_fw - qr_fw);
    } else {
        qr_val = qr_val >> (qr_fw - y_fw);
    }

    if( (a_sgnd == 1 && b_sgnd == 0) || (a_sgnd == 0 && b_sgnd == 1) ){
        qr_val = -(qr_val);
    }
    return qr_val;
}

#endif

